//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41FE88DC0171.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41FE88DC0171.cm

//## begin module%41FE88DC0171.cp preserve=no
//## end module%41FE88DC0171.cp

//## Module: ModularCounter%41FE88DC0171; Package body
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/ModularCounter.cxx

//## begin module%41FE88DC0171.additionalIncludes preserve=no
//## end module%41FE88DC0171.additionalIncludes

//## begin module%41FE88DC0171.includes preserve=yes
#include <XSUtil/Error/Error.h>
//## end module%41FE88DC0171.includes

// ModularCounter
#include <XSUtil/Numerics/ModularCounter.h>
//## begin module%41FE88DC0171.declarations preserve=no
//## end module%41FE88DC0171.declarations

//## begin module%41FE88DC0171.additionalDeclarations preserve=yes
//## end module%41FE88DC0171.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    // Class Numerics::ModularCounter 

    ModularCounter::ModularCounter (const IntegerArray& bases)
      //## begin Numerics::ModularCounter::ModularCounter%41FE8AD00387.hasinit preserve=yes
      : m_bases(bases),
        m_counter(bases.size(), 0),
        m_totalCount(0)
      //## end Numerics::ModularCounter::ModularCounter%41FE8AD00387.hasinit
      //## begin Numerics::ModularCounter::ModularCounter%41FE8AD00387.initialization preserve=yes
      //## end Numerics::ModularCounter::ModularCounter%41FE8AD00387.initialization
    {
      //## begin Numerics::ModularCounter::ModularCounter%41FE8AD00387.body preserve=yes
       size_t sz = bases.size();
       if (!sz)
       {
          throw RedAlert("Cannot create ModularCounter of size 0");
       }
       for (size_t i=0; i<sz; ++i)
       {
          if (!bases[i]) 
                throw RedAlert("Cannot create ModularCounter with 0 base.");
       }
      //## end Numerics::ModularCounter::ModularCounter%41FE8AD00387.body
    }


    ModularCounter::~ModularCounter()
    {
      //## begin Numerics::ModularCounter::~ModularCounter%41FE890F0099_dest.body preserve=yes
      //## end Numerics::ModularCounter::~ModularCounter%41FE890F0099_dest.body
    }


    ModularCounter & ModularCounter::operator=(const ModularCounter &right)
    {
      //## begin Numerics::ModularCounter::operator=%41FE890F0099_assign.body preserve=yes
       if (this != &right) 
       {
          m_bases = right.m_bases;
          m_counter = right.m_counter;
          m_totalCount = right.m_totalCount;
       }
       return *this;  
      //## end Numerics::ModularCounter::operator=%41FE890F0099_assign.body
    }



    //## Other Operations (implementation)
    void ModularCounter::adjust ()
    {
      //## begin Numerics::ModularCounter::adjust%41FE8D4600B9.body preserve=yes
       bool finished = false;
       size_t sz = m_counter.size();
       for (size_t i=0; i<sz && !finished; ++i)
       {
          if (m_counter[i] < 0)
          {
             if (i == sz-1)
             {
                rollBack();
                finished = true;
             }
             else
             {
                m_counter[i] = m_bases[i] - 1;
                m_counter[i+1] -= 1; 
             }  
          }
          else if (m_counter[i] >= m_bases[i])
          {
             if (i == sz-1)
             {
                reset();
                finished = true;
             }
             else
             {
                m_counter[i] = 0;
                m_counter[i+1] += 1;
             }
          }
          else
          {
             finished = true;
          }
       }
      //## end Numerics::ModularCounter::adjust%41FE8D4600B9.body
    }

    ModularCounter& ModularCounter::operator ++ ()
    {
      //## begin Numerics::ModularCounter::operator++%41FE8D5F00F6.body preserve=yes
       m_counter[0] += 1;
       ++m_totalCount;
       adjust();
       return *this;
      //## end Numerics::ModularCounter::operator++%41FE8D5F00F6.body
    }

    const ModularCounter ModularCounter::operator ++ (int i)
    {
      //## begin Numerics::ModularCounter::operator++%41FE8D9902A4.body preserve=yes
       ModularCounter oldValue(*this);
       ++(*this);
       return oldValue;
      //## end Numerics::ModularCounter::operator++%41FE8D9902A4.body
    }

    ModularCounter& ModularCounter::operator -- ()
    {
      //## begin Numerics::ModularCounter::operator--%41FE8DCC018A.body preserve=yes
       if (m_totalCount)
       {
          m_counter[0] -= 1;
          --m_totalCount;
          adjust();
       }
       else
       {
          rollBack();
       }
       return *this;
      //## end Numerics::ModularCounter::operator--%41FE8DCC018A.body
    }

    const ModularCounter ModularCounter::operator -- (int i)
    {
      //## begin Numerics::ModularCounter::operator--%41FE8DE40274.body preserve=yes
       ModularCounter oldValue(*this);
       --(*this);
       return oldValue;
      //## end Numerics::ModularCounter::operator--%41FE8DE40274.body
    }

    void ModularCounter::rollBack ()
    {
      //## begin Numerics::ModularCounter::rollBack%41FE97EF032E.body preserve=yes
       m_totalCount = 1;
       for (size_t i=0; i<m_bases.size(); ++i)
       {
          m_counter[i] = m_bases[i] - 1;
          m_totalCount *= m_bases[i];
       }
      //## end Numerics::ModularCounter::rollBack%41FE97EF032E.body
    }

    // Additional Declarations
      //## begin Numerics::ModularCounter%41FE890F0099.declarations preserve=yes
      //## end Numerics::ModularCounter%41FE890F0099.declarations

} // namespace Numerics

//## begin module%41FE88DC0171.epilog preserve=yes
//## end module%41FE88DC0171.epilog
